/*
 * Copyright (C) 2017  Kevin Whitaker <eyecreate@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef USERACTION_H
#define USERACTION_H

#include <Wt/Dbo/Dbo>
#include <Wt/WDateTime>
#include <Wt/Dbo/WtSqlTraits>
#include "User.h"
#include "AudioTrack.h"

class UserAction
{
public:
    enum UAction {Login = 0, Logout = 1, RequestTrack = 2, VoteTrack = 3, UploadTrack = 4, RequestSkip = 5, PlayPause = 6};
    
    Wt::Dbo::ptr<User> user;
    UAction action;
    Wt::Dbo::ptr<AudioTrack> trackInvolved;
    Wt::WDateTime datetime;
    
    template<class Action>
    void persist(Action& a)
    {
        Wt::Dbo::belongsTo(a, user, "user", Wt::Dbo::OnDeleteCascade);
        Wt::Dbo::field(a, action, "action");
        Wt::Dbo::belongsTo(a, trackInvolved, "track", Wt::Dbo::OnDeleteCascade);
        Wt::Dbo::field(a, datetime, "datetime");
    }
    
};

#endif
